--- sim_ether.c.orig	2008-04-24 17:11:42.000000000 +1000
+++ sim_ether.c	2011-08-18 03:09:39.000000000 +1000
@@ -138,6 +138,7 @@
 
   Modification history:
 
+  20-Aug-10  TVO  Fix for Mac OSX 10.6
   17-May-07  DTH  Fixed non-ethernet device removal loop (from Naoki Hamada)
   15-May-07  DTH  Added dynamic loading of wpcap.dll;
                   Corrected exceed max index bug in ethX lookup
@@ -630,7 +631,7 @@ int eth_devices (int max, ETH_LIST* dev)
 /*        OpenVMS Alpha uses a WinPcap port and an associated execlet         */
 /*============================================================================*/
 
-#if defined (xBSD) && !defined(__APPLE__)
+#if defined (xBSD) || defined(__APPLE__)
 #include <sys/ioctl.h>
 #include <net/bpf.h>
 #endif /* xBSD */
@@ -975,6 +976,15 @@ t_stat eth_open(ETH_DEV* dev, char* name
   }
 #endif
 #endif /* !defined (USE_READER_THREAD */
+#if defined (__APPLE__)
+  /* Deliver packets immediately, needed for OS X 10.6.2 and later
+   * (Snow-Leopard).
+   * See this thread on libpcap and Mac Os X 10.6 Snow Leopard on
+   * the tcpdump mailinglist: http://seclists.org/tcpdump/2010/q1/110
+   */
+  int v = 1;
+  ioctl(pcap_fileno(dev->handle), BIOCIMMEDIATE, &v);
+#endif
   return SCPE_OK;
 }
 
